/*
 * bin_sem.h
 *
 *  Created on: May 14, 2011
 *      Author: kfclan
 */

#ifndef BIN_SEM_H_
#define BIN_SEM_H_
#include <sys/types.h>

/* We must define union semun ourselves. */
union semun {
	int val;
	struct semid_ds *buf;
	unsigned short int *array;
	struct seminfo *__buf;
};

#define SEMGO 0
#define SEMSTOP 1
#define VIRHOST 0

int semaphore_create(key_t sem_key, int num_semaphores);
int semaphore_attach(key_t sem_key, int num_semaphores);
void semaphore_setval(int semid, int index, int value);
void semaphore_remove(int semid);
void semaphore_wait(int semid, int index);
void semaphore_post(int semid, int index);
void semaphore_waitforzero(int semid, int index);
void semaphore_waitforzero_maskallsig(int semid, int index);

#endif /* BIN_SEM_H_ */

// The follwing code remains just in case of future debug purpose.  - by hlee
//#define SYNCMGR_PHASE1 1
//#define SYNCMGR_PHASE2 2
//#define SYNCMGRCTL 3
//#define SEMIDXZERO 0

///* #define for Readers-Writers Problem */
//#define RSEM 0
//#define WSEM 1
//#define XSEM 2
//#define YSEM 3
//#define ZSEM 4

//int binary_semaphore_initialize(int semid);
//int binary_semaphore_allocation(key_t key, int sem_flags);
//int binary_semaphore_deallocate(int semid);
//int binary_semaphore_wait(int semid);
//int binary_semaphore_post(int semid);

//int readerswriters_create(key_t sem_key);
//int readerswriters_attach(key_t sem_key, key_t key_readcount, key_t key_writecount);
//void readerswriters_detach(void);
//void readerswriters_remove(int semid);
//void readerswriters_initialize(int semid, key_t key_readcount, key_t key_writecount);
//void readers_wait(int semid);
//void readers_post(int semid);
//void writers_wait(int semid);
//void writers_post(int semid);


