
#include <stdio.h>
#include <sys/socket.h>

ssize_t sendp(int sockfd, const void *msg, size_t msg_len) {
	if (send(sockfd, &msg_len, sizeof(size_t), 0) != sizeof(size_t)) {
		perror("send() sent a different number of bytes than expected");
		return -1;
	}

	return send(sockfd, msg, msg_len, 0);
}

ssize_t recvp(int sockfd, void *msg) {
	size_t msg_len;
	if ((recv(sockfd, &msg_len, sizeof(size_t), MSG_WAITALL)) != sizeof(size_t)) {
		perror("recv() received a different number of bytes than expected");
		return -1;
	}
	return recv(sockfd, msg, msg_len, MSG_WAITALL);
}

